var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var RES;
(function (RES) {
    var ResourceNodeType;
    (function (ResourceNodeType) {
        ResourceNodeType[ResourceNodeType["FILE"] = 0] = "FILE";
        ResourceNodeType[ResourceNodeType["DICTIONARY"] = 1] = "DICTIONARY";
    })(ResourceNodeType || (ResourceNodeType = {}));
    function getResourceInfo(path) {
        var result = FileSystem.getFile(path);
        if (!result) {
            path = RES.resourceNameSelector(path);
            result = FileSystem.getFile(path);
        }
        return result;
    }
    RES.getResourceInfo = getResourceInfo;
    var FileSystem;
    (function (FileSystem) {
        FileSystem.data = {};
        function addFile(filename, type) {
            if (!type)
                type = "";
            filename = normalize(filename);
            var basefilename = basename(filename);
            var folder = dirname(filename);
            if (!exists(folder)) {
                mkdir(folder);
            }
            var d = reslove(folder);
            d[basefilename] = { url: filename, type: type };
        }
        FileSystem.addFile = addFile;
        function getFile(filename) {
            var result = reslove(filename);
            if (result) {
                result.name = filename;
            }
            return result;
        }
        FileSystem.getFile = getFile;
        function basename(filename) {
            return filename.substr(filename.lastIndexOf("/") + 1);
        }
        function normalize(filename) {
            return filename.split("/").filter(function (d) { return !!d; }).join("/");
        }
        function dirname(path) {
            return path.substr(0, path.lastIndexOf("/"));
        }
        function reslove(dirpath) {
            if (dirpath == "") {
                return FileSystem.data;
            }
            dirpath = normalize(dirpath);
            var list = dirpath.split("/");
            var current = FileSystem.data;
            for (var _i = 0, list_1 = list; _i < list_1.length; _i++) {
                var f = list_1[_i];
                if (current) {
                    current = current[f];
                }
                else {
                    return current;
                }
            }
            return current;
        }
        function mkdir(dirpath) {
            dirpath = normalize(dirpath);
            var list = dirpath.split("/");
            var current = FileSystem.data;
            for (var _i = 0, list_2 = list; _i < list_2.length; _i++) {
                var f = list_2[_i];
                if (!current[f]) {
                    current[f] = {};
                }
                current = current[f];
            }
        }
        FileSystem.mkdir = mkdir;
        function exists(dirpath) {
            if (dirpath == "")
                return true;
            dirpath = normalize(dirpath);
            var list = dirpath.split("/");
            var current = FileSystem.data;
            for (var _i = 0, list_3 = list; _i < list_3.length; _i++) {
                var f = list_3[_i];
                if (!current[f]) {
                    return false;
                }
                current = current[f];
            }
            return true;
        }
        FileSystem.exists = exists;
    })(FileSystem = RES.FileSystem || (RES.FileSystem = {}));
})(RES || (RES = {}));
var RES;
(function (RES) {
    RES.resourceNameSelector = function (p) { return p; };
    var configItem;
    function setConfigURL(url) {
        configItem = { type: 'commonjs', resourceRoot: RES.resourceRoot, url: url, name: url };
    }
    RES.setConfigURL = setConfigURL;
    RES.resourceRoot = "";
    /**
     * @class RES.ResourceConfig
     * @classdesc
     * @private
     */
    var ResourceConfig = (function () {
        function ResourceConfig() {
        }
        ResourceConfig.prototype.init = function () {
            var _this = this;
            return RES.queue.loadResource(configItem).then(function (data) {
                return _this.parseConfig(data);
            }).catch(function (e) {
                if (!e.__resource_manager_error__) {
                    console.error(e.stack);
                    e = new RES.ResourceManagerError(1002);
                }
                return Promise.reject(e);
            });
        };
        /**
         * @internal
         */
        ResourceConfig.prototype.getGroupByName = function (name, shouldNotBeNull) {
            var group = this.config.groups[name];
            var result = [];
            if (!group) {
                if (shouldNotBeNull) {
                    throw new RES.ResourceManagerError(2005, name);
                }
                return null;
            }
            for (var _i = 0, group_1 = group; _i < group_1.length; _i++) {
                var paramKey = group_1[_i];
                var _a = RES.config.getResourceWithSubkey(paramKey, true), key = _a.key, subkey = _a.subkey;
                var r = RES.config.getResource(key, true);
                if (result.indexOf(r) == -1) {
                    result.push(r);
                }
            }
            return result;
        };
        ResourceConfig.prototype.__temp__get__type__via__url = function (url_or_alias) {
            var url = this.config.alias[url_or_alias];
            if (!url) {
                url = url_or_alias;
            }
            if (RES.resourceTypeSelector) {
                var type = RES.resourceTypeSelector(url);
                if (!type) {
                    throw new RES.ResourceManagerError(2004, url);
                }
                return type;
            }
            else {
                console.warn("RES.mapConfig 并未设置 typeSelector");
                return "unknown";
            }
        };
        ResourceConfig.prototype.getResourceWithSubkey = function (key, shouldNotBeNull) {
            key = this.getKeyByAlias(key);
            var index = key.indexOf("#");
            var subkey = "";
            if (index >= 0) {
                subkey = key.substr(index + 1);
                key = key.substr(0, index);
            }
            var r = this.getResource(key);
            if (!r) {
                if (shouldNotBeNull) {
                    var msg = subkey ? key + "#" + subkey : key;
                    throw new RES.ResourceManagerError(2006, msg);
                }
                else {
                    return null;
                }
            }
            else {
                return {
                    r: r, key: key, subkey: subkey
                };
            }
        };
        ResourceConfig.prototype.getKeyByAlias = function (aliasName) {
            if (this.config.alias[aliasName]) {
                return this.config.alias[aliasName];
            }
            else {
                return aliasName;
            }
        };
        ResourceConfig.prototype.getResource = function (path_or_alias, shouldNotBeNull) {
            var path = this.config.alias[path_or_alias];
            if (!path) {
                path = path_or_alias;
            }
            var file = RES.getResourceInfo(path);
            var r = file;
            if (!r) {
                if (shouldNotBeNull) {
                    throw new RES.ResourceManagerError(2006, path_or_alias);
                }
                return null;
            }
            r;
            return r;
        };
        /**
         * 根据组名获取原始的组加载项列表
         * @method RES.ResourceConfig#getRawGroupByName
         * @param name {string} 组名
         * @returns {Array<any>}
         * @internal
         */
        ResourceConfig.prototype.getGroup = function (name) {
            return this.getGroupByName(name);
        };
        // public getResourceInfos(folderName: string) {
        //     this.config.resources[]
        // }
        /**
         * 创建自定义的加载资源组,注意：此方法仅在资源配置文件加载完成后执行才有效。
         * 可以监听ResourceEvent.CONFIG_COMPLETE事件来确认配置加载完成。
         * @method RES.ResourceConfig#createGroup
         * @param name {string} 要创建的加载资源组的组名
         * @param keys {egret.Array<string>} 要包含的键名列表，key对应配置文件里的name属性或sbuKeys属性的一项或一个资源组名。
         * @param override {boolean} 是否覆盖已经存在的同名资源组,默认false。
         * @returns {boolean}
         */
        ResourceConfig.prototype.createGroup = function (name, keys, override) {
            if (override === void 0) { override = false; }
            if ((!override && this.config.groups[name]) || !keys || keys.length == 0) {
                return false;
            }
            var group = [];
            for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
                var key = keys_1[_i];
                if (this.config.groups[key]) {
                    var groupInfo = this.config.groups[key];
                    group = group.concat(groupInfo);
                }
                else {
                    group.push(key);
                }
            }
            this.config.groups[name] = group;
            return true;
            // var groupDic: any = this.groupDic;
            // var group: Array<any> = [];
            // var length: number = keys.length;
            // for (var i: number = 0; i < length; i++) {
            //     var key: string = keys[i];
            //     var g: Array<any> = groupDic[key];
            //     if (g) {
            //         var len: number = g.length;
            //         for (var j: number = 0; j < len; j++) {
            //             var item: any = g[j];
            //             if (group.indexOf(item) == -1)
            //                 group.push(item);
            //         }
            //     }
            //     else {
            //         item = this.keyMap[key];
            //         if (item) {
            //             if (group.indexOf(item) == -1)
            //                 group.push(item);
            //         }
            //         else {
            //             egret.$warn(3200, key);
            //         }
            //     }
            // }
            // if (group.length == 0)
            //     return false;
            // this.groupDic[name] = group;
            // return true;
        };
        /**
         * 解析一个配置文件
         * @method RES.ResourceConfig#parseConfig
         * @param data {any} 配置文件数据
         * @param folder {string} 加载项的路径前缀。
         */
        ResourceConfig.prototype.parseConfig = function (data) {
            RES.resourceRoot = data.resourceRoot + "/";
            this.config = data;
            RES.resourceTypeSelector = data.typeSelector;
            RES.resourceMergerSelector = data.mergeSelector;
            RES.FileSystem.data = data.resources;
            // if (!data)
            //     return;
            // var resources: Array<any> = data["resources"];
            // if (resources) {
            //     var length: number = resources.length;
            //     for (var i: number = 0; i < length; i++) {
            //         var item: any = resources[i];
            //         var url: string = item.url;
            //         if (url && url.indexOf("://") == -1)
            //             item.url = folder + url;
            //         this.addItemToKeyMap(item);
            //     }
            // }
            // var groups: Array<any> = data["groups"];
            // if (groups) {
            //     length = groups.length;
            //     for (i = 0; i < length; i++) {
            //         var group: any = groups[i];
            //         var list: Array<any> = [];
            //         var keys: Array<string> = (<string>group.keys).split(",");
            //         var l: number = keys.length;
            //         for (var j: number = 0; j < l; j++) {
            //             var name: string = keys[j].trim();
            //             item = this.keyMap[name];
            //             if (item && list.indexOf(item) == -1) {
            //                 list.push(item);
            //             }
            //         }
            //         this.groupDic[group.name] = list;
            //     }
            // }
        };
        /**
         * 添加一个二级键名到配置列表。
         * @method RES.ResourceConfig#addSubkey
         * @param subkey {string} 要添加的二级键名
         * @param name {string} 二级键名所属的资源name属性
         */
        ResourceConfig.prototype.addSubkey = function (subkey, name) {
            this.addAlias(subkey, name + "#" + subkey);
        };
        ResourceConfig.prototype.addAlias = function (alias, key) {
            if (this.config.alias[key]) {
                key = this.config.alias[key];
            }
            this.config.alias[alias] = key;
        };
        /**
         * 获取加载项类型。
         * @method RES.ResourceConfig#getType
         * @param key {string} 对应配置文件里的name属性或sbuKeys属性的一项。
         * @returns {string}
         */
        ResourceConfig.prototype.getType = function (key) {
            return this.getResource(key, true).type;
        };
        ResourceConfig.prototype.addResourceData = function (data) {
            if (!data.type) {
                data.type = this.__temp__get__type__via__url(data.url);
            }
            RES.FileSystem.addFile(data.url, data.type);
            if (data.name) {
                this.config.alias[data.name] = data.url;
            }
        };
        ResourceConfig.prototype.destory = function () {
            RES.systemPid++;
            this.config = { groups: {}, alias: {}, resources: {}, typeSelector: function (p) { return p; }, resourceRoot: "resources", mergeSelector: null };
            RES.FileSystem.data = {};
        };
        return ResourceConfig;
    }());
    RES.ResourceConfig = ResourceConfig;
})(RES || (RES = {}));
//////////////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 2014-present, Egret Technology.
//  All rights reserved.
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the Egret nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
//  THIS SOFTWARE IS PROVIDED BY EGRET AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
//  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
//  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
//  IN NO EVENT SHALL EGRET AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;LOSS OF USE, DATA,
//  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//////////////////////////////////////////////////////////////////////////////////////
var RES;
(function (RES) {
    /**
     * @class RES.ResourceLoader
     * @classdesc
     * @private
     */
    var ResourceLoader = (function () {
        function ResourceLoader() {
        }
        ResourceLoader.prototype.load = function (list, reporter) {
            var _this = this;
            var current = 0;
            var total = 1;
            var mapper = function (r) {
                return _this.loadResource(r)
                    .then(function (response) {
                    RES.host.save(r, response);
                    current++;
                    if (reporter && reporter.onProgress) {
                        reporter.onProgress(current, total);
                    }
                    return response;
                });
            };
            total = list.length;
            return Promise.all(list.map(mapper));
        };
        ;
        ResourceLoader.prototype.loadResource = function (r, p) {
            if (!p) {
                if (RES.FEATURE_FLAG.FIX_DUPLICATE_LOAD == 1) {
                    var s = RES.host.state[r.name];
                    if (s == 2) {
                        return Promise.resolve(RES.host.get(r));
                    }
                    if (s == 1) {
                        return r.promise;
                    }
                }
                p = RES.processor.isSupport(r);
            }
            if (!p) {
                throw new RES.ResourceManagerError(2001, r.name, r.type);
            }
            RES.host.state[r.name] = 1;
            var promise = p.onLoadStart(RES.host, r);
            r.promise = promise;
            return promise;
        };
        ResourceLoader.prototype.unloadResource = function (r) {
            var data = RES.host.get(r);
            if (!data) {
                console.warn("尝试释放不存在的资源:", r.name);
                return Promise.resolve();
            }
            var p = RES.processor.isSupport(r);
            if (p) {
                RES.host.state[r.name] = 3;
                return p.onRemoveStart(RES.host, r)
                    .then(function (result) {
                    RES.host.remove(r);
                    return result;
                });
            }
            else {
                return Promise.resolve();
            }
        };
        return ResourceLoader;
    }());
    RES.ResourceLoader = ResourceLoader;
})(RES || (RES = {}));
var RES;
(function (RES) {
    var __tempCache = {};
    /**
     * 整个资源加载系统的进程id，协助管理回调派发机制
     */
    RES.systemPid = 0;
    RES.checkCancelation = function (target, propertyKey, descriptor) {
        var method = descriptor.value;
        descriptor.value = function () {
            var arg = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                arg[_i] = arguments[_i];
            }
            var currentPid = RES.systemPid;
            var result = method.apply(this, arg);
            return result.then(function (value) {
                if (RES.systemPid != currentPid) {
                    throw new ResourceManagerError(1005, arg[0]);
                }
                else {
                    return value;
                }
            });
        };
    };
    function profile() {
        console.log(RES.FileSystem.data);
        console.log(__tempCache);
        //todo 
        var totalImageSize = 0;
        for (var key in __tempCache) {
            var img = __tempCache[key];
            if (img instanceof egret.Texture) {
                totalImageSize += img._bitmapWidth * img._bitmapHeight * 4;
            }
        }
        console.log("gpu size : " + (totalImageSize / 1024).toFixed(3) + "kb");
    }
    RES.profile = profile;
    RES.host = {
        state: {},
        get resourceConfig() {
            return RES.config;
        },
        load: function (r, processor) { return RES.queue.loadResource(r, processor); },
        unload: function (r) { return RES.queue.unloadResource(r); },
        save: function (resource, data) {
            RES.host.state[resource.name] = 2;
            resource.promise = undefined;
            __tempCache[resource.url] = data;
        },
        get: function (resource) {
            return __tempCache[resource.url];
        },
        remove: function (resource) {
            RES.host.state[resource.name] = 0;
            delete __tempCache[resource.url];
        }
    };
    RES.config = new RES.ResourceConfig();
    RES.queue = new RES.ResourceLoader();
    var ResourceManagerError = (function (_super) {
        __extends(ResourceManagerError, _super);
        function ResourceManagerError(code, replacer, replacer2) {
            var _this = _super.call(this) || this;
            /**
             * why instanceof e  != ResourceManagerError ???
             * see link : https://github.com/Microsoft/TypeScript/wiki/Breaking-Changes#extending-built-ins-like-error-array-and-map-may-no-longer-work
             */
            _this.__resource_manager_error__ = true;
            _this.name = code.toString();
            _this.message = ResourceManagerError.errorMessage[code].replace("{0}", replacer).replace("{1}", replacer2);
            return _this;
        }
        return ResourceManagerError;
    }(Error));
    ResourceManagerError.errorMessage = {
        1001: '文件加载失败:{0}',
        1002: "ResourceManager 初始化失败：配置文件加载失败",
        1005: 'ResourceManager 已被销毁，文件加载失败:{0}',
        2001: "{0}解析失败,不支持指定解析类型:\'{1}\'，请编写自定义 Processor ，更多内容请参见 https://github.com/egret-labs/resourcemanager/blob/master/docs/README.md#processor",
        2002: "Analyzer 相关API 在 ResourceManager 中不再支持，请编写自定义 Processor ，更多内容请参见 https://github.com/egret-labs/resourcemanager/blob/master/docs/README.md#processor",
        2003: "{0}解析失败,错误原因:{1}",
        2004: "无法找到文件类型:{0}",
        2005: "资源配置文件中无法找到特定的资源组:{0}",
        2006: "资源配置文件中无法找到特定的资源:{0}"
    };
    RES.ResourceManagerError = ResourceManagerError;
})(RES || (RES = {}));
var RES;
(function (RES) {
    var processor;
    (function (processor_1) {
        function isSupport(resource) {
            return _map[resource.type];
        }
        processor_1.isSupport = isSupport;
        function map(type, processor) {
            _map[type] = processor;
        }
        processor_1.map = map;
        function promisify(loader, resource) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    return [2 /*return*/, new Promise(function (reslove, reject) {
                            var onSuccess = function () {
                                var texture = loader['data'] ? loader['data'] : loader['response'];
                                reslove(texture);
                            };
                            var onError = function () {
                                var e = new RES.ResourceManagerError(1001, resource.url);
                                reject(e);
                            };
                            loader.addEventListener(egret.Event.COMPLETE, onSuccess, _this);
                            loader.addEventListener(egret.IOErrorEvent.IO_ERROR, onError, _this);
                        })];
                });
            });
        }
        function getURL(resource) {
            var prefix = resource.extra ? "" : RES.resourceRoot;
            var url = prefix + resource.url;
            if (RES['getRealURL']) {
                return RES['getRealURL'](url);
            }
            else {
                return url;
            }
        }
        function getRelativePath(url, file) {
            url = url.split("\\").join("/");
            var params = url.match(/#.*|\?.*/);
            var paramUrl = "";
            if (params) {
                paramUrl = params[0];
            }
            var index = url.lastIndexOf("/");
            if (index != -1) {
                url = url.substring(0, index + 1) + file;
            }
            else {
                url = file;
            }
            return url + paramUrl;
        }
        processor_1.getRelativePath = getRelativePath;
        // var cache: {[index:string]:egret.Texture} = {};
        processor_1.ImageProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var loader, bitmapData, texture;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                loader = new egret.ImageLoader();
                                loader.load(getURL(resource));
                                return [4 /*yield*/, promisify(loader, resource)];
                            case 1:
                                bitmapData = _a.sent();
                                texture = new egret.Texture();
                                texture._setBitmapData(bitmapData);
                                // var config: any = resItem.data;
                                // if (config && config["scale9grid"]) {
                                //     var str: string = config["scale9grid"];
                                //     var list: Array<string> = str.split(",");
                                //     texture["scale9Grid"] = new egret.Rectangle(parseInt(list[0]), parseInt(list[1]), parseInt(list[2]), parseInt(list[3]));
                                // }
                                return [2 /*return*/, texture];
                        }
                    });
                });
            },
            onRemoveStart: function (host, resource) {
                var texture = host.get(resource);
                texture.dispose();
                return Promise.resolve();
            }
        };
        processor_1.BinaryProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var request, arraybuffer;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                request = new egret.HttpRequest();
                                request.responseType = egret.HttpResponseType.ARRAY_BUFFER;
                                request.open(getURL(resource), "get");
                                request.send();
                                return [4 /*yield*/, promisify(request, resource)];
                            case 1:
                                arraybuffer = _a.sent();
                                return [2 /*return*/, arraybuffer];
                        }
                    });
                });
            },
            onRemoveStart: function (host, resource) {
                return Promise.resolve();
            }
        };
        processor_1.TextProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var request, text;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                request = new egret.HttpRequest();
                                request.responseType = egret.HttpResponseType.TEXT;
                                request.open(getURL(resource), "get");
                                request.send();
                                return [4 /*yield*/, promisify(request, resource)];
                            case 1:
                                text = _a.sent();
                                return [2 /*return*/, text];
                        }
                    });
                });
            },
            onRemoveStart: function (host, resource) {
                return Promise.resolve();
            }
        };
        processor_1.JsonProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var text, data;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, host.load(resource, processor_1.TextProcessor)];
                            case 1:
                                text = _a.sent();
                                data = JSON.parse(text);
                                return [2 /*return*/, data];
                        }
                    });
                });
            },
            onRemoveStart: function (host, request) {
                return Promise.resolve();
            }
        };
        processor_1.XMLProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var text, data;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, host.load(resource, processor_1.TextProcessor)];
                            case 1:
                                text = _a.sent();
                                data = egret.XML.parse(text);
                                return [2 /*return*/, data];
                        }
                    });
                });
            },
            onRemoveStart: function (host, resource) {
                return Promise.resolve();
            }
        };
        processor_1.CommonJSProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var text, f, require, exports;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, host.load(resource, processor_1.TextProcessor)];
                            case 1:
                                text = _a.sent();
                                f = new Function('require', 'exports', text);
                                require = function () { };
                                exports = {};
                                try {
                                    f(require, exports);
                                }
                                catch (e) {
                                    throw new RES.ResourceManagerError(2003, resource.name, e.message);
                                }
                                return [2 /*return*/, exports];
                        }
                    });
                });
            },
            onRemoveStart: function (host, resource) {
                return Promise.resolve();
            }
        };
        processor_1.SheetProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var data, imagePath, r, texture, frames, spriteSheet, subkey, config, texture;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, host.load(resource, processor_1.JsonProcessor)];
                            case 1:
                                data = _a.sent();
                                imagePath = getRelativePath(resource.name, data.file);
                                r = host.resourceConfig.getResource(imagePath);
                                if (!r) {
                                    throw new RES.ResourceManagerError(1001, imagePath);
                                }
                                return [4 /*yield*/, host.load(r)];
                            case 2:
                                texture = _a.sent();
                                frames = data.frames;
                                spriteSheet = new egret.SpriteSheet(texture);
                                for (subkey in frames) {
                                    config = frames[subkey];
                                    texture = spriteSheet.createTexture(subkey, config.x, config.y, config.w, config.h, config.offX, config.offY, config.sourceW, config.sourceH);
                                }
                                return [2 /*return*/, spriteSheet];
                        }
                    });
                });
            },
            getData: function (host, resource, key, subkey) {
                var data = host.get(resource);
                if (data) {
                    return data.getTexture(subkey);
                }
                else {
                    console.error("missing resource : " + key + "#" + subkey);
                    return null;
                }
            },
            onRemoveStart: function (host, resource) {
                return Promise.resolve();
            }
        };
        processor_1.FontProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var getTexturePath, data, imageUrl, config, r, texture, font;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                getTexturePath = function (url, fntText) {
                                    var file = "";
                                    var lines = fntText.split("\n");
                                    var pngLine = lines[2];
                                    var index = pngLine.indexOf("file=\"");
                                    if (index != -1) {
                                        pngLine = pngLine.substring(index + 6);
                                        index = pngLine.indexOf("\"");
                                        file = pngLine.substring(0, index);
                                    }
                                    url = url.split("\\").join("/");
                                    var index = url.lastIndexOf("/");
                                    if (index != -1) {
                                        url = url.substring(0, index + 1) + file;
                                    }
                                    else {
                                        url = file;
                                    }
                                    return url;
                                };
                                return [4 /*yield*/, host.load(resource, processor_1.TextProcessor)];
                            case 1:
                                data = _a.sent();
                                imageUrl = "";
                                try {
                                    config = JSON.parse(data);
                                    imageUrl = resource.name.replace("fnt", "png");
                                }
                                catch (e) {
                                    config = data;
                                    // imageUrl = getTexturePath(resource.name, data);
                                    imageUrl = resource.name.replace("fnt", "png");
                                    ;
                                }
                                r = host.resourceConfig.getResource(imageUrl);
                                if (!r) return [3 /*break*/, 3];
                                return [4 /*yield*/, host.load(r)];
                            case 2:
                                texture = _a.sent();
                                font = new egret.BitmapFont(texture, config);
                                return [2 /*return*/, font];
                            case 3: return [2 /*return*/, null];
                        }
                    });
                });
            },
            onRemoveStart: function (host, resource) {
                return Promise.resolve();
            }
        };
        processor_1.SoundProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var sound;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                sound = new egret.Sound();
                                sound.load(getURL(resource));
                                return [4 /*yield*/, promisify(sound, resource)];
                            case 1:
                                _a.sent();
                                return [2 /*return*/, sound];
                        }
                    });
                });
            },
            onRemoveStart: function (host, resource) {
                return Promise.resolve();
            }
        };
        processor_1.MovieClipProcessor = {
            onLoadStart: function (host, resource) {
                var mcData;
                var imageResource;
                return host.load(resource, processor_1.JsonProcessor)
                    .then(function (value) {
                    mcData = value;
                    var jsonPath = resource.name;
                    var imagePath = jsonPath.substring(0, jsonPath.lastIndexOf(".")) + ".png";
                    imageResource = host.resourceConfig.getResource(imagePath, true);
                    if (!imageResource) {
                        throw new RES.ResourceManagerError(1001, imagePath);
                    }
                    return host.load(imageResource);
                }).then(function (value) {
                    host.save(imageResource, value);
                    var mcTexture = value;
                    var mcDataFactory = new egret.MovieClipDataFactory(mcData, mcTexture);
                    return mcDataFactory;
                });
            },
            onRemoveStart: function (host, resource) {
                var mcFactory = host.get(resource);
                mcFactory.clearCache();
                mcFactory.$spriteSheet.dispose();
                // refactor
                var jsonPath = resource.name;
                var imagePath = jsonPath.substring(0, jsonPath.lastIndexOf(".")) + ".png";
                var imageResource = host.resourceConfig.getResource(imagePath, true);
                var image = host.get(imageResource);
                host.remove(imageResource);
                image.dispose();
                return Promise.resolve();
            }
        };
        processor_1.MergeJSONProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var data, key;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, host.load(resource, processor_1.JsonProcessor)];
                            case 1:
                                data = _a.sent();
                                for (key in data) {
                                    RES.config.addSubkey(key, resource.name);
                                }
                                return [2 /*return*/, data];
                        }
                    });
                });
            },
            getData: function (host, resource, key, subkey) {
                var data = host.get(resource);
                if (data) {
                    return data[subkey];
                }
                else {
                    console.error("missing resource :" + resource.name);
                    return null;
                }
            },
            onRemoveStart: function (host, resource) {
                return Promise.resolve();
            }
        };
        processor_1.ResourceConfigProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var data, resources, loop, isFile;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, host.load(resource, processor_1.JsonProcessor)];
                            case 1:
                                data = _a.sent();
                                resources = data.resources;
                                loop = function (r, prefix, walk) {
                                    for (var key in r) {
                                        var p = prefix ? prefix + "/" + key : key;
                                        var f = r[key];
                                        if (isFile(f)) {
                                            if (typeof f === 'string') {
                                                f = { url: f, name: p };
                                                r[key] = f;
                                            }
                                            else {
                                                f['name'] = p;
                                            }
                                            walk(f);
                                        }
                                        else {
                                            loop(f, p, walk);
                                        }
                                    }
                                };
                                isFile = function (r) {
                                    return typeof r === "string" || r.url != null;
                                };
                                loop(resources, "", function (value) {
                                    if (!value.type) {
                                        value.type = RES.resourceTypeSelector(value.url);
                                    }
                                });
                                return [2 /*return*/, data];
                        }
                    });
                });
            },
            onRemoveStart: function () {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        return [2 /*return*/];
                    });
                });
            }
        };
        var PVRParser = (function () {
            function PVRParser() {
            }
            PVRParser.parse = function (arrayBuffer, callback, errorCallback) {
                // the header length of int32
                var headerIntLength = 13;
                // get header part of arrayBuffer
                var header = new Uint32Array(arrayBuffer, 0, headerIntLength);
                // separate buffer and header
                var pvrDatas = {
                    buffer: arrayBuffer,
                    header: header
                };
                // PVR v3
                if (header[0] === 0x03525650) {
                    PVRParser._parseV3(pvrDatas, callback, errorCallback);
                }
                else if (header[11] === 0x21525650) {
                    PVRParser._parseV2(pvrDatas, callback, errorCallback);
                }
                else {
                    errorCallback(pvrDatas, "pvr parse error!");
                }
            };
            PVRParser._parseV2 = function (pvrDatas, callback, errorCallback) {
                var header = pvrDatas.header;
                var headerLength = header[0], height = header[1], width = header[2], numMipmaps = header[3], flags = header[4], dataLength = header[5], bpp = header[6], bitmaskRed = header[7], bitmaskGreen = header[8], bitmaskBlue = header[9], bitmaskAlpha = header[10], pvrTag = header[11], numSurfs = header[12];
                var TYPE_MASK = 0xff;
                var PVRTC_2 = 24, PVRTC_4 = 25;
                var formatFlags = flags & TYPE_MASK;
                var bpp, format;
                var _hasAlpha = bitmaskAlpha > 0;
                if (formatFlags === PVRTC_4) {
                    format = _hasAlpha ? PVRParser.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG : PVRParser.COMPRESSED_RGB_PVRTC_4BPPV1_IMG;
                    bpp = 4;
                }
                else if (formatFlags === PVRTC_2) {
                    format = _hasAlpha ? PVRParser.COMPRESSED_RGBA_PVRTC_2BPPV1_IMG : PVRParser.COMPRESSED_RGB_PVRTC_2BPPV1_IMG;
                    bpp = 2;
                }
                else {
                    errorCallback(pvrDatas, "pvr v2 parse error");
                    console.log("unknow format flags::" + formatFlags);
                }
                var dataOffset = headerLength;
                pvrDatas.pvrtcData = new Uint8Array(pvrDatas.buffer, dataOffset);
                pvrDatas.bpp = bpp;
                pvrDatas.format = format;
                pvrDatas.width = width;
                pvrDatas.height = height;
                pvrDatas.surfacesCount = numSurfs;
                pvrDatas.mipmapsCount = numMipmaps + 1;
                // guess cubemap type seems tricky in v2
                // it juste a pvr containing 6 surface (no explicit cubemap type)
                pvrDatas.isCubemap = (pvrDatas.surfacesCount === 6);
                callback(pvrDatas);
            };
            PVRParser._parseV3 = function (pvrDatas, callback, errorCallback) {
                var header = pvrDatas.header;
                var bpp, format;
                var pixelFormat = header[2];
                switch (pixelFormat) {
                    case 0:
                        bpp = 2;
                        format = PVRParser.COMPRESSED_RGB_PVRTC_2BPPV1_IMG;
                        break;
                    case 1:
                        bpp = 2;
                        format = PVRParser.COMPRESSED_RGBA_PVRTC_2BPPV1_IMG;
                        break;
                    case 2:
                        bpp = 4;
                        format = PVRParser.COMPRESSED_RGB_PVRTC_4BPPV1_IMG;
                        break;
                    case 3:
                        bpp = 4;
                        format = PVRParser.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG;
                        break;
                    default:
                        errorCallback(pvrDatas, "pvr v3 parse error");
                        console.log("unknow pixel format::" + pixelFormat);
                }
                var dataOffset = 52 + header[12];
                pvrDatas.pvrtcData = new Uint8Array(pvrDatas.buffer, dataOffset);
                pvrDatas.bpp = bpp;
                pvrDatas.format = format;
                pvrDatas.width = header[7];
                pvrDatas.height = header[6];
                pvrDatas.surfacesCount = header[10];
                pvrDatas.mipmapsCount = header[11];
                pvrDatas.isCubemap = (pvrDatas.surfacesCount === 6);
                callback(pvrDatas);
            };
            return PVRParser;
        }());
        PVRParser.COMPRESSED_RGB_PVRTC_4BPPV1_IMG = 0x8C00;
        PVRParser.COMPRESSED_RGB_PVRTC_2BPPV1_IMG = 0x8C01;
        PVRParser.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG = 0x8C02;
        PVRParser.COMPRESSED_RGBA_PVRTC_2BPPV1_IMG = 0x8C03;
        if (typeof egret != 'undefined' && egret && egret["web"] && egret["web"].WebGLRenderContext) {
            // Calcualates the size of a compressed texture level in bytes
            function textureLevelSize(format, width, height) {
                switch (format) {
                    case PVRParser.COMPRESSED_RGB_PVRTC_4BPPV1_IMG:
                    case PVRParser.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG:
                        return Math.floor((Math.max(width, 8) * Math.max(height, 8) * 4 + 7) / 8);
                    case PVRParser.COMPRESSED_RGB_PVRTC_2BPPV1_IMG:
                    case PVRParser.COMPRESSED_RGBA_PVRTC_2BPPV1_IMG:
                        return Math.floor((Math.max(width, 16) * Math.max(height, 8) * 2 + 7) / 8);
                    default:
                        return 0;
                }
            }
            egret["web"].WebGLRenderContext.prototype.createTextureFromCompressedData = function (data, width, height, levels, internalFormat) {
                var gl = this.context;
                if (!this.pvrtcExt) {
                    this.pvrtcExt = gl.getExtension("WEBKIT_WEBGL_compressed_texture_pvrtc");
                }
                var texture = gl.createTexture();
                gl.bindTexture(gl.TEXTURE_2D, texture);
                var offset = 0;
                // Loop through each mip level of compressed texture data provided and upload it to the given texture.
                for (var i = 0; i < levels; ++i) {
                    // Determine how big this level of compressed texture data is in bytes.
                    var levelSize = textureLevelSize(internalFormat, width, height);
                    // Get a view of the bytes for this level of DXT data.
                    var dxtLevel = new Uint8Array(data.buffer, data.byteOffset + offset, levelSize);
                    // Upload!
                    gl.compressedTexImage2D(gl.TEXTURE_2D, i, internalFormat, width, height, 0, dxtLevel);
                    // The next mip level will be half the height and width of this one.
                    width = width >> 1;
                    if (width < 1)
                        width = 1;
                    height = height >> 1;
                    if (height < 1)
                        height = 1;
                    // Advance the offset into the compressed texture data past the current mip level's data.
                    offset += levelSize;
                }
                gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
                gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
                return texture;
            };
        }
        processor_1.PVRProcessor = {
            onLoadStart: function (host, resource) {
                return __awaiter(this, void 0, void 0, function () {
                    var arraybuffer, width, height, borderWidth, borderHeight, byteArray, list, pvrDataBuffer, i, buffer, dataLength, self, texture;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, host.load(resource, processor_1.BinaryProcessor)];
                            case 1:
                                arraybuffer = _a.sent();
                                width = 512;
                                height = 512;
                                borderWidth = 0;
                                borderHeight = 0;
                                byteArray = new egret.ByteArray(arraybuffer);
                                byteArray.position = 7;
                                list = ["body", "ext"];
                                for (i = 0; i < list.length; i++) {
                                    buffer = void 0;
                                    switch (list[i]) {
                                        case "body":
                                            byteArray.position += 2;
                                            dataLength = byteArray.readUnsignedInt();
                                            pvrDataBuffer = byteArray.buffer.slice(byteArray.position, byteArray.position + dataLength);
                                            byteArray.position += dataLength;
                                            break;
                                        case "ext":
                                            byteArray.position += 6;
                                            width = byteArray.readUnsignedShort();
                                            height = byteArray.readUnsignedShort();
                                            borderWidth = byteArray.readUnsignedShort();
                                            borderHeight = byteArray.readUnsignedShort();
                                            break;
                                    }
                                }
                                self = this;
                                PVRParser.parse(pvrDataBuffer, function (pvrData) {
                                    var bitmapData = new egret.BitmapData(pvrData);
                                    bitmapData.format = "pvr";
                                    texture = new egret.Texture();
                                    texture._setBitmapData(bitmapData);
                                    texture.$initData(borderWidth, borderHeight, width, height, 0, 0, width, height, bitmapData.width, bitmapData.height);
                                }, function () {
                                    console.log("pvr error");
                                });
                                return [2 /*return*/, texture];
                        }
                    });
                });
            },
            onRemoveStart: function (host, resource) {
                return Promise.resolve();
            }
        };
        // export const ZipProcessor: Processor = {
        //     onLoadStart(host, resource) {
        //         return host.load(resource, BinaryProcessor).then((arraybuffer) => {
        //             var zip = new ZipFile(arraybuffer);
        //             return zip;
        //         })
        //     },
        //     onRemoveStart() {
        //         return Promise.resolve();
        //     },
        //     getData(host, resource, key, subkey) {
        //         let zip: ZipFile = host.get(resource);
        //         let subResource: ArrayBuffer = zip.read(subkey);
        //         let text = String.fromCharCode.apply(null, new Uint16Array(subResource));
        //         //todo:refactor
        //         if (subkey.indexOf(".json") >= 0) {
        //             return JSON.parse(text)
        //         }
        //         else {
        //             return text;
        //         }
        //     }
        // }
        var _map = {
            "image": processor_1.ImageProcessor,
            "json": processor_1.JsonProcessor,
            "text": processor_1.TextProcessor,
            "xml": processor_1.XMLProcessor,
            "sheet": processor_1.SheetProcessor,
            "font": processor_1.FontProcessor,
            "bin": processor_1.BinaryProcessor,
            "commonjs": processor_1.CommonJSProcessor,
            "sound": processor_1.SoundProcessor,
            "movieclip": processor_1.MovieClipProcessor,
            "pvr": processor_1.PVRProcessor,
            "mergeJson": processor_1.MergeJSONProcessor,
            "resourceConfig": processor_1.ResourceConfigProcessor,
        };
    })(processor = RES.processor || (RES.processor = {}));
})(RES || (RES = {}));
var RES;
(function (RES) {
    RES.checkNull = function (target, propertyKey, descriptor) {
        var method = descriptor.value;
        descriptor.value = function () {
            var arg = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                arg[_i] = arguments[_i];
            }
            if (!arg[0]) {
                console.warn("\u65B9\u6CD5" + propertyKey + "\u7684\u53C2\u6570\u4E0D\u80FD\u4E3Anull");
                return null;
            }
            else {
                return method.apply(this, arg);
            }
        };
    };
    /**
     * 功能开关
     *  LOADING_STATE：处理重复加载
     */
    RES.FEATURE_FLAG = {
        FIX_DUPLICATE_LOAD: 1
    };
    var upgrade;
    (function (upgrade) {
        var _level = "warning";
        function setUpgradeGuideLevel(level) {
            _level = level;
        }
        upgrade.setUpgradeGuideLevel = setUpgradeGuideLevel;
    })(upgrade = RES.upgrade || (RES.upgrade = {}));
})(RES || (RES = {}));
